/*
 *		ソフトウェア割込みによるサービスコール呼出し
 *
 *  このヘッダファイルは，kernel.hからインクルードされる．他のファイル
 *  から直接インクルードすることはない．
 * 
 *  $Id: target_svc.h 1133 2022-10-21 02:03:21Z ertl-hiro $
 */

#ifndef TOPPERS_TARGET_SVC_H
#define TOPPERS_TARGET_SVC_H

/*
 *  macOS上のシミュレーション環境では，ソフトウェア割込みを使用するこ
 *  とができないため，カーネルのサービスコール呼出しには関数呼出しを用
 *  いる．
 */
#define TOPPERS_SVC_CALL_KERNEL

/*
 *  cal_svcサービスコールの呼出し
 */
extern ER_UINT _kernel_extsvc_entry(FN fncd, intptr_t par1, intptr_t par2,
							intptr_t par3, intptr_t par4, intptr_t par5);

Inline ER_UINT
cal_svc(FN fncd, intptr_t par1, intptr_t par2,
							intptr_t par3, intptr_t par4, intptr_t par5)
{
	return(_kernel_extsvc_entry(fncd, par1, par2, par3, par4, par5));
}

#endif /* TOPPERS_TARGET_SVC_H */
